import { Provider, Branch } from './types';
export default class Bitbucket implements Provider {
    private baseUrl;
    private authenticationHeader;
    private timeout;
    constructor(opts: {
        password: string;
        username?: string;
        refreshToken?: string;
        expires?: number;
        type: 'basic' | 'oauth2' | 'PAT';
        apiURL?: string;
        timeout?: number;
    });
    private performAPICall;
    fetchRawFile(opts: {
        owner: string;
        repo: string;
        ref: string;
        path: string;
    }): Promise<string>;
    getBranch(opts: {
        owner: string;
        repo: string;
        branch: string;
    }): Promise<Branch>;
}
