"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var rest_1 = require("@octokit/rest");
var helpers_1 = require("../helpers");
// tslint:disable-next-line: no-var-requires
var CFError = require('cf-errors');
// tslint:disable-next-line: no-var-requires
var logger = require('cf-logs').Logger('codefresh:infra:git-providers:github');
var _cleanFilePath = function (filepath) {
    var prefix = './';
    var hasPrefix = filepath.indexOf(prefix) === 0;
    var path = hasPrefix ? filepath.substring(prefix.length) : filepath;
    return path;
};
var Github = /** @class */ (function () {
    function Github(opt) {
        var pathPrefix = (opt.apiPathPrefix && opt.apiPathPrefix !== '/') ? opt.apiPathPrefix : '';
        this.githubClient = new rest_1.Octokit({
            userAgent: 'Codefresh',
            auth: opt.password,
            request: {
                timeout: opt.timeout || 10000
            },
            timeout: opt.timeout || 10000,
            host: opt.apiHost || 'api.github.com',
            log: logger,
            debug: true,
            baseUrl: "https://" + (opt.apiHost || 'api.github.com') + pathPrefix
        });
    }
    Github.prototype.fetchRawFile = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var owner, repo, ref, path, _a, err, res, data, base64Content;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        owner = opt.owner, repo = opt.repo, ref = opt.ref, path = opt.path;
                        return [4 /*yield*/, helpers_1.to(this.githubClient.repos.getContent({ owner: owner, repo: repo, path: _cleanFilePath(path), ref: ref }))];
                    case 1:
                        _a = _b.sent(), err = _a[0], res = _a[1];
                        if (err) {
                            throw new CFError({
                                message: "Failed to retrieve file: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to retrieve file: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        data = res.data;
                        base64Content = data.content.replace(/\n/ig, '');
                        return [2 /*return*/, Buffer.from(base64Content, 'base64').toString()];
                }
            });
        });
    };
    Github.prototype.getBranch = function (opt) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, err, res;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0: return [4 /*yield*/, helpers_1.to(this.githubClient.repos.getBranch(opt))];
                    case 1:
                        _a = _b.sent(), err = _a[0], res = _a[1];
                        if (err) {
                            throw new CFError({
                                message: "Failed to retrieve branch: " + JSON.stringify(opt) + ", status code: " + err.status,
                                cause: err
                            });
                        }
                        else if (res.status >= 400) {
                            throw new CFError("Failed to retrieve branch: " + JSON.stringify(opt) + ", status code: " + res.status);
                        }
                        return [2 /*return*/, {
                                id: res.data.name,
                                name: res.data.name,
                                commit: {
                                    sha: res.data.commit.sha,
                                    commiter_name: res.data.commit.commit.author.name,
                                    message: res.data.commit.commit.message,
                                    url: res.data.commit.commit.url
                                }
                            }];
                }
            });
        });
    };
    return Github;
}());
exports["default"] = Github;
//# sourceMappingURL=github.js.map