export declare type ProviderConstructor = new (opt: {
    password: string;
    username?: string;
    isPrivateToken?: boolean;
    refreshToken?: string;
    type: 'basic' | 'oauth2' | 'PAT';
    apiPathPrefix?: string;
    apiHost?: string;
    apiURL?: string;
    timeout?: number;
    expires?: number;
}) => Provider;
export interface Provider {
    fetchRawFile(opt: {
        owner: string;
        repo: string;
        ref: string;
        path: string;
    }): Promise<string>;
    getBranch(opt: {
        owner: string;
        repo: string;
        branch: string;
    }): Promise<Branch>;
}
export interface Branch {
    name: string;
    id: string;
    commit: Commit;
}
export interface Commit {
    sha: string;
    message: string;
    commiter_name: string;
    url: string;
}
